digit7 () {
	case ${#1} in
	1)
		echo 000000$1 ;;
	2)
		echo 00000$1 ;;
	3)
		echo 0000$1 ;;
	4)
		echo 000$1 ;;
	5)
		echo 00$1 ;;
	6)
		echo 0$1 ;;
	*)
		echo $1 ;;
	esac
}

addnum () {
	lnum=1
	read oneline
	while test $? -eq 0
	do
		echo "$oneline `digit7 $lnum`"
		let lnum=$lnum+1
		echo -n "." 1>&2
		read oneline
	done
}

mkduplist () {
	pl="firstline"
	read ol
	while test $? -eq 0
	do
		unset --
		set -- $ol
		if test $# -eq 2
		then
			if test "$pl" == "$1"
			then
				echo "`expr $2 + 0`"
			fi
			pl="$1"
		else
			pl="[no_name]"
		fi
#		echo -n "." 1>&2
		read ol
	done
}

mkmvsub () {
	read ol
	while test $? -eq 0
	do
		echo "${lbuf[$ol]}"
#		echo -n "." 1>&2
		read ol
	done
}

mkmvlist () {
	lnum=1
	read ol
	while test $? -eq 0
	do
		lbuf[$lnum]="$ol"
		let lnum=$lnum+1
#		echo -n "." 1>&2
		read ol
	done
	mkmvsub < duplist.txt
}

mvsub () {
	read ol
	while test $? -eq 0
	do
		if test -f "`echo \"$chkdir$ol\" | nkf -E -s -x`"
		then
			mv "`echo \"$chkdir$ol\" | nkf -E -s -x`" "`echo \"$dupfiledir$ol\" | nkf -E -s -x`"
		else
			echo "no such file: `echo \"$chkdir$ol\" | nkf -E -s -x`"
		fi
		echo -n "." 1>&2
		read ol
	done
}

##### ݒ#####
##### ȉ2sҏWāAftHgŃ`FbNfBNgƁAdlt@C̈ړfBNgw肵ĂB #####

chkdir='dummyfiles/'
dupfiledir='dup/'

##### ݒ܂ #####

case $# in
	0)
		;;
	1)
		chkdir="$1";;
	2)
		chkdir="$1"
		dupfiledir="$2";;
	*)
		echo "error: too many parameters"
		exit;;
esac

if test "${chkdir:(${#chkdir}-1):1}" != "/"
then
	chkdir="$chkdir/"
fi

if test "${dupfiledir:(${#dupfiledir}-1):1}" != "/"
then
	dupfiledir="$dupfiledir/"
fi

if test ! -d "$chkdir"
then
	echo "no such directory: $chkdir"
	exit
fi

if test ! -d "$dupfiledir"
then
	echo "no such directory: $dupfiledir"
	exit
fi

echo "*** This script moves files having similar names under $chkdir to $dupfiledir ***" 1>&2

echo "Phase 1 of 7; Creating file list to check." 1>&2

##### ̍s -S  -t ɕύXƁAłVt@Cc܂B̂܂܂ƁAłTCY傫ȃt@Cc܂B#####
ls -S "$chkdir" > list.txt

filecnt="`cat list.txt | wc -l `"
echo "	done. There are $filecnt files to be checked." 1>&2

echo "Phase 2 of 7; Creating list of simplified file names." 1>&2

##### sedŃt@CP邽߂̃XNvgłB KXύXĂB#####
##### ʗނŕꂽ폜SpXy[X폜gq폜S9ƂSɒuǗyz폜 #####
sedscr="-e s/([^)]*)//g  -e s/\[[^\[]*\]//g -e s/y[^z]*z//g -e s/@//g -e s/\.[^\.]*$//g -e s/S[0-9]*/S/g -e s/y//g -e s/z//g"

##### ̍sLƖ̐폜܂ #####
sedscr="$sedscr -e s/[0-9]*$//g"

##### ̃XNvgeucR[hɂĕϐɃZbg #####
euc_sedscr="`echo \"$sedscr\" | nkf -S -e -x`"

##### sedXNvgspXy[XƊʗނ폜 #####
##### ̍sLɂeucR[hŃt@CȗXĝŃXgȂȂ܂Ao[W1.7.5cygwinłsedIȂȂ܂B#####
#nkf -S -e -Z0 list.txt | sed $euc_sedscr | tr -d ' ()[]'  > solist.txt
##### ̍sLɂƃXg̈ꕔ܂ɕ܂A吨ɉe͂܂B#####
nkf -S -s -Z0 list.txt | sed $sedscr | tr -d ' ()[]'  > solist.txt

echo "	done." 1>&2

echo "Phase 3 of 7; Appending line numbers to the list of simplified file names." 1>&2

#####̍sLɂƁAsԍtɓTu[`gp܂ƂĂxłB#####
#addnum < solist.txt > solistn.txt
./addnum.exe < solist.txt > solistn.txt
##### addnum.exe삵ȂƂ́A̍sRgɂ邩Abuild_addnum.batsărhĂB#####

echo "	done." 1>&2

echo "Phase 4 of 6; Sorting the list of simplified file names." 1>&2
sort solistn.txt > solistns.txt
echo "	done." 1>&2

echo "Phase 5 of 7; Extracting line numbers of files having similar names." 1>&2
mkduplist < solistns.txt > duplist.txt
dupcnt="`cat duplist.txt | wc -l `"
echo "	done."
echo "	$dupcnt files having similar names found." 1>&2

echo "Phase 6 of 7; Converting the line numbers to corresponding file names." 1>&2
nkf -S -e -x list.txt | mkmvlist > mvlist.txt
echo "	done." 1>&2

echo "Phase 7 of 7; moving files having similar names." 1>&2
mvsub < mvlist.txt
echo "	done." 1>&2

